//                              --- OpenGL 1.3 ---

#ifndef GL_VERSION_1_3
#define GL_VERSION_1_3 1
#define __GENERATE_GL_13__

extern bool GLEH_OPENGL_1_3; /**< @brief set if OpenGL 1.3 is supported */

#define GL_TEXTURE0                                                 0x84C0
#define GL_TEXTURE1                                                 0x84C1
#define GL_TEXTURE2                                                 0x84C2
#define GL_TEXTURE3                                                 0x84C3
#define GL_TEXTURE4                                                 0x84C4
#define GL_TEXTURE5                                                 0x84C5
#define GL_TEXTURE6                                                 0x84C6
#define GL_TEXTURE7                                                 0x84C7
#define GL_TEXTURE8                                                 0x84C8
#define GL_TEXTURE9                                                 0x84C9
#define GL_TEXTURE10                                                0x84CA
#define GL_TEXTURE11                                                0x84CB
#define GL_TEXTURE12                                                0x84CC
#define GL_TEXTURE13                                                0x84CD
#define GL_TEXTURE14                                                0x84CE
#define GL_TEXTURE15                                                0x84CF
#define GL_TEXTURE16                                                0x84D0
#define GL_TEXTURE17                                                0x84D1
#define GL_TEXTURE18                                                0x84D2
#define GL_TEXTURE19                                                0x84D3
#define GL_TEXTURE20                                                0x84D4
#define GL_TEXTURE21                                                0x84D5
#define GL_TEXTURE22                                                0x84D6
#define GL_TEXTURE23                                                0x84D7
#define GL_TEXTURE24                                                0x84D8
#define GL_TEXTURE25                                                0x84D9
#define GL_TEXTURE26                                                0x84DA
#define GL_TEXTURE27                                                0x84DB
#define GL_TEXTURE28                                                0x84DC
#define GL_TEXTURE29                                                0x84DD
#define GL_TEXTURE30                                                0x84DE
#define GL_TEXTURE31                                                0x84DF
#define GL_ACTIVE_TEXTURE                                           0x84E0
//#define GL_CLIENT_ACTIVE_TEXTURE                                    0x84E1 // deprecated
//#define GL_MAX_TEXTURE_UNITS                                        0x84E2 // deprecated
//#define GL_TRANSPOSE_MODELVIEW_MATRIX                               0x84E3 // deprecated
//#define GL_TRANSPOSE_PROJECTION_MATRIX                              0x84E4 // deprecated
//#define GL_TRANSPOSE_TEXTURE_MATRIX                                 0x84E5 // deprecated
//#define GL_TRANSPOSE_COLOR_MATRIX                                   0x84E6 // deprecated
#define GL_MULTISAMPLE                                              0x809D
#define GL_SAMPLE_ALPHA_TO_COVERAGE                                 0x809E
#define GL_SAMPLE_ALPHA_TO_ONE                                      0x809F
#define GL_SAMPLE_COVERAGE                                          0x80A0
#define GL_SAMPLE_BUFFERS                                           0x80A8
#define GL_SAMPLES                                                  0x80A9
#define GL_SAMPLE_COVERAGE_VALUE                                    0x80AA
#define GL_SAMPLE_COVERAGE_INVERT                                   0x80AB
//#define GL_MULTISAMPLE_BIT                                          0x20000000 // deprecated
//#define GL_NORMAL_MAP                                               0x8511 // deprecated
//#define GL_REFLECTION_MAP                                           0x8512 // deprecated
#define GL_TEXTURE_CUBE_MAP                                         0x8513
#define GL_TEXTURE_BINDING_CUBE_MAP                                 0x8514
#define GL_TEXTURE_CUBE_MAP_POSITIVE_X                              0x8515
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X                              0x8516
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y                              0x8517
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y                              0x8518
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z                              0x8519
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z                              0x851A
#define GL_PROXY_TEXTURE_CUBE_MAP                                   0x851B
#define GL_MAX_CUBE_MAP_TEXTURE_SIZE                                0x851C
//#define GL_COMPRESSED_ALPHA                                         0x84E9 // deprecated
//#define GL_COMPRESSED_LUMINANCE                                     0x84EA // deprecated
//#define GL_COMPRESSED_LUMINANCE_ALPHA                               0x84EB // deprecated
//#define GL_COMPRESSED_INTENSITY                                     0x84EC // deprecated
#define GL_COMPRESSED_RGB                                           0x84ED
#define GL_COMPRESSED_RGBA                                          0x84EE
#define GL_TEXTURE_COMPRESSION_HINT                                 0x84EF
#define GL_TEXTURE_COMPRESSED_IMAGE_SIZE                            0x86A0
#define GL_TEXTURE_COMPRESSED                                       0x86A1
#define GL_NUM_COMPRESSED_TEXTURE_FORMATS                           0x86A2
#define GL_COMPRESSED_TEXTURE_FORMATS                               0x86A3
#define GL_CLAMP_TO_BORDER                                          0x812D
//#define GL_COMBINE                                                  0x8570 // deprecated
//#define GL_COMBINE_RGB                                              0x8571 // deprecated
//#define GL_COMBINE_ALPHA                                            0x8572 // deprecated
//#define GL_SOURCE0_RGB                                              0x8580 // deprecated
//#define GL_SOURCE1_RGB                                              0x8581 // deprecated
//#define GL_SOURCE2_RGB                                              0x8582 // deprecated
//#define GL_SOURCE0_ALPHA                                            0x8588 // deprecated
//#define GL_SOURCE1_ALPHA                                            0x8589 // deprecated
//#define GL_SOURCE2_ALPHA                                            0x858A // deprecated
//#define GL_OPERAND0_RGB                                             0x8590 // deprecated
//#define GL_OPERAND1_RGB                                             0x8591 // deprecated
//#define GL_OPERAND2_RGB                                             0x8592 // deprecated
//#define GL_OPERAND0_ALPHA                                           0x8598 // deprecated
//#define GL_OPERAND1_ALPHA                                           0x8599 // deprecated
//#define GL_OPERAND2_ALPHA                                           0x859A // deprecated
//#define GL_RGB_SCALE                                                0x8573 // deprecated
//#define GL_ADD_SIGNED                                               0x8574 // deprecated
//#define GL_INTERPOLATE                                              0x8575 // deprecated
//#define GL_SUBTRACT                                                 0x84E7 // deprecated
//#define GL_CONSTANT                                                 0x8576 // deprecated
//#define GL_PRIMARY_COLOR                                            0x8577 // deprecated
//#define GL_PREVIOUS                                                 0x8578 // deprecated
//#define GL_DOT3_RGB                                                 0x86AE // deprecated
//#define GL_DOT3_RGBA                                                0x86AF // deprecated

/**
 *  @brief select active texture unit
 *  @param[in] texture Specifies which texture unit to make active. The number of texture units is
 *      implementation dependent, but must be at least 80. texture must be one of GL_TEXTURE i,
 *      where i ranges from 0 ( GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS - 1). The initial value is GL_TEXTURE0.
 */
extern void (GLApi *GLFuncPtrName(glActiveTexture))(GLenum texture);

/**
 *  @brief specify multisample coverage parameters
 *  @param[in] value Specify a single floating-point sample coverage value. The value is clamped to
 *      the range 0 1. The initial value is 1.0.
 *  @param[in] invert Specify a single boolean value representing if the coverage masks should be
 *      inverted. GL_TRUE and GL_FALSE are accepted. The initial value is GL_FALSE.
 */
extern void (GLApi *GLFuncPtrName(glSampleCoverage))(GLclampf value, GLboolean invert);

/**
 *  @brief specify a three-dimensional texture image in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D,
 *      GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] internalformat Specifies the format of the compressed image data stored at address data.
 *  @param[in] width Specifies the width of the texture image. All implementations support 3D
 *      texture images that are at least 16 texels wide.
 *  @param[in] height Specifies the height of the texture image. All implementations support 3D
 *      texture images that are at least 16 texels high.
 *  @param[in] depth Specifies the depth of the texture image. All implementations support 3D
 *      texture images that are at least 16 texels deep.
 *  @param[in] border This value must be 0.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
extern void (GLApi *GLFuncPtrName(glCompressedTexImage3D))(GLenum target, int level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, int border, GLsizei imageSize, const void *data);

/**
 *  @brief specify a two-dimensional texture image in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D,
 *      GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X,
 *      GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
 *      GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] internalformat Specifies the format of the compressed image data stored at address data.
 *  @param[in] width Specifies the width of the texture image. All implementations support 2D
 *      texture images that are at least 64 texels wide and cube-mapped texture images that are at
 *      least 16 texels wide.
 *  @param[in] height Specifies the height of the texture image. All implementations support 2D
 *      texture images that are at least 64 texels high and cube-mapped texture images that are at
 *      least 16 texels high.
 *  @param[in] border This value must be 0.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
extern void (GLApi *GLFuncPtrName(glCompressedTexImage2D))(GLenum target, int level, GLenum internalformat, GLsizei width, GLsizei height, int border, GLsizei imageSize, const void *data);

/**
 *  @brief specify a one-dimensional texture image in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] internalformat Specifies the format of the compressed image data stored at address data.
 *  @param[in] width Specifies the width of the texture image. All implementations support texture
 *      images that are at least 64 texels wide. The height of the 1D texture image is 1.
 *  @param[in] border This value must be 0.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
extern void (GLApi *GLFuncPtrName(glCompressedTexImage1D))(GLenum target, int level, GLenum internalformat, GLsizei width, int border, GLsizei imageSize, const void *data);

/**
 *  @brief specify a three-dimensional texture subimage in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_3D.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] xoffset Specifies a texel offset in the x direction within the texture array.
 *  @param[in] yoffset Specifies a texel offset in the y direction within the texture array.
 *  @param[in] zoffset Specifies a texel offset in the z direction within the texture array.
 *  @param[in] width Specifies the width of the texture subimage.
 *  @param[in] height Specifies the height of the texture subimage.
 *  @param[in] depth Specifies the depth of the texture subimage.
 *  @param[in] format Specifies the format of the compressed image data stored at address data.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
extern void (GLApi *GLFuncPtrName(glCompressedTexSubImage3D))(GLenum target, int level, int xoffset, int yoffset, int zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const void *data);

/**
 *  @brief specify a two-dimensional texture subimage in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_2D,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] xoffset Specifies a texel offset in the x direction within the texture array.
 *  @param[in] yoffset Specifies a texel offset in the y direction within the texture array.
 *  @param[in] width Specifies the width of the texture subimage.
 *  @param[in] height Specifies the height of the texture subimage.
 *  @param[in] format Specifies the format of the compressed image data stored at address data.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
extern void (GLApi *GLFuncPtrName(glCompressedTexSubImage2D))(GLenum target, int level, int xoffset, int yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const void *data);

/**
 *  @brief specify a one-dimensional texture subimage in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_1D.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] xoffset Specifies a texel offset in the x direction within the texture array.
 *  @param[in] width Specifies the width of the texture subimage.
 *  @param[in] format Specifies the format of the compressed image data stored at address data.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
extern void (GLApi *GLFuncPtrName(glCompressedTexSubImage1D))(GLenum target, int level, int xoffset, GLsizei width, GLenum format, GLsizei imageSize, const void *data);

/**
 *  @brief return a compressed texture image
 *  @param[in] target Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D,
 *      GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
 *  @param[in] lod Specifies the level-of-detail number of the desired image. Level 0 is the base
 *      image level. Level n is the nth mipmap reduction image.
 *  @param[out] img Returns the compressed texture image.
 */
extern void (GLApi *GLFuncPtrName(glGetCompressedTexImage))(GLenum target, int lod, void *img);

// functions below are deprecated
/*extern void (GLApi *GLFuncPtrName(glLoadTransposeMatrixf))(const GLfloat*);
extern void (GLApi *GLFuncPtrName(glLoadTransposeMatrixd))(const GLdouble*);
extern void (GLApi *GLFuncPtrName(glMultTransposeMatrixf))(const GLfloat*);
extern void (GLApi *GLFuncPtrName(glMultTransposeMatrixd))(const GLdouble*);
extern void (GLApi *GLFuncPtrName(glClientActiveTexture))(GLenum);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord1d))(GLenum, GLdouble);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord1dv))(GLenum, const GLdouble*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord1f))(GLenum, GLfloat);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord1fv))(GLenum, const GLfloat*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord1i))(GLenum, GLint);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord1iv))(GLenum, const GLint*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord1s))(GLenum, GLshort);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord1sv))(GLenum, const GLshort*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord2d))(GLenum, GLdouble, GLdouble);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord2dv))(GLenum, const GLdouble*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord2f))(GLenum, GLfloat, GLfloat);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord2fv))(GLenum, const GLfloat*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord2i))(GLenum, GLint, GLint);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord2iv))(GLenum, const GLint*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord2s))(GLenum, GLshort, GLshort);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord2sv))(GLenum, const GLshort*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord3d))(GLenum, GLdouble, GLdouble, GLdouble);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord3dv))(GLenum, const GLdouble*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord3f))(GLenum, GLfloat, GLfloat, GLfloat);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord3fv))(GLenum, const GLfloat*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord3i))(GLenum, GLint, GLint, GLint);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord3iv))(GLenum, const GLint*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord3s))(GLenum, GLshort, GLshort, GLshort);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord3sv))(GLenum, const GLshort*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord4d))(GLenum, GLdouble, GLdouble, GLdouble, GLdouble);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord4dv))(GLenum, const GLdouble*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord4f))(GLenum, GLfloat, GLfloat, GLfloat, GLfloat);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord4fv))(GLenum, const GLfloat*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord4i))(GLenum, GLint, GLint, GLint, GLint);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord4iv))(GLenum, const GLint*);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord4s))(GLenum, GLshort, GLshort, GLshort, GLshort);
extern void (GLApi *GLFuncPtrName(glMultiTexCoord4sv))(GLenum, const GLshort*);*/

/**
 *  @def glActiveTexture
 *  @brief select active texture unit
 *  @param[in] texture Specifies which texture unit to make active. The number of texture units is
 *      implementation dependent, but must be at least 80. texture must be one of GL_TEXTURE i,
 *      where i ranges from 0 ( GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS - 1). The initial value is GL_TEXTURE0.
 */
#define glActiveTexture(texture) do { GLFuncPtrName(glActiveTexture)(texture); GL_AUTOCHECK_BLOCK("glActiveTexture", __FILE__, __LINE__); } while(0)

/**
 *  @def glSampleCoverage
 *  @brief specify multisample coverage parameters
 *  @param[in] value Specify a single floating-point sample coverage value. The value is clamped to
 *      the range 0 1. The initial value is 1.0.
 *  @param[in] invert Specify a single boolean value representing if the coverage masks should be
 *      inverted. GL_TRUE and GL_FALSE are accepted. The initial value is GL_FALSE.
 */
#define glSampleCoverage(value,invert) do { GLFuncPtrName(glSampleCoverage)(value, invert); GL_AUTOCHECK_BLOCK("glSampleCoverage", __FILE__, __LINE__); } while(0)

/**
 *  @def glCompressedTexImage3D
 *  @brief specify a three-dimensional texture image in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_3D, GL_PROXY_TEXTURE_3D,
 *      GL_TEXTURE_2D_ARRAY or GL_PROXY_TEXTURE_2D_ARRAY.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] internalformat Specifies the format of the compressed image data stored at address data.
 *  @param[in] width Specifies the width of the texture image. All implementations support 3D
 *      texture images that are at least 16 texels wide.
 *  @param[in] height Specifies the height of the texture image. All implementations support 3D
 *      texture images that are at least 16 texels high.
 *  @param[in] depth Specifies the depth of the texture image. All implementations support 3D
 *      texture images that are at least 16 texels deep.
 *  @param[in] border This value must be 0.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
#define glCompressedTexImage3D(target,level,internalformat,width,height,depth,border,imageSize,data) do { GLFuncPtrName(glCompressedTexImage3D)(target, level, internalformat, width, height, depth, border, imageSize, data); GL_AUTOCHECK_BLOCK("glCompressedTexImage3D", __FILE__, __LINE__); } while(0)

/**
 *  @def glCompressedTexImage2D
 *  @brief specify a two-dimensional texture image in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D,
 *      GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_CUBE_MAP_POSITIVE_X,
 *      GL_TEXTURE_CUBE_MAP_NEGATIVE_X, GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
 *      GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] internalformat Specifies the format of the compressed image data stored at address data.
 *  @param[in] width Specifies the width of the texture image. All implementations support 2D
 *      texture images that are at least 64 texels wide and cube-mapped texture images that are at
 *      least 16 texels wide.
 *  @param[in] height Specifies the height of the texture image. All implementations support 2D
 *      texture images that are at least 64 texels high and cube-mapped texture images that are at
 *      least 16 texels high.
 *  @param[in] border This value must be 0.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
#define glCompressedTexImage2D(target,level,internalformat,width,height,border,imageSize,data) do { GLFuncPtrName(glCompressedTexImage2D)(target, level, internalformat, width, height, border, imageSize, data); GL_AUTOCHECK_BLOCK("glCompressedTexImage2D", __FILE__, __LINE__); } while(0)

/**
 *  @def glCompressedTexImage1D
 *  @brief specify a one-dimensional texture image in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] internalformat Specifies the format of the compressed image data stored at address data.
 *  @param[in] width Specifies the width of the texture image. All implementations support texture
 *      images that are at least 64 texels wide. The height of the 1D texture image is 1.
 *  @param[in] border This value must be 0.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
#define glCompressedTexImage1D(target,level,internalformat,width,border,imageSize,data) do { GLFuncPtrName(glCompressedTexImage1D)(target, level, internalformat, width, border, imageSize, data); GL_AUTOCHECK_BLOCK("glCompressedTexImage1D", __FILE__, __LINE__); } while(0)

/**
 *  @def glCompressedTexSubImage3D
 *  @brief specify a three-dimensional texture subimage in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_3D.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] xoffset Specifies a texel offset in the x direction within the texture array.
 *  @param[in] yoffset Specifies a texel offset in the y direction within the texture array.
 *  @param[in] zoffset Specifies a texel offset in the z direction within the texture array.
 *  @param[in] width Specifies the width of the texture subimage.
 *  @param[in] height Specifies the height of the texture subimage.
 *  @param[in] depth Specifies the depth of the texture subimage.
 *  @param[in] format Specifies the format of the compressed image data stored at address data.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
#define glCompressedTexSubImage3D(target,level,xoffset,yoffset,zoffset,width,height,depth,format,imageSize,data) do { GLFuncPtrName(glCompressedTexSubImage3D)(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data); GL_AUTOCHECK_BLOCK("glCompressedTexSubImage3D", __FILE__, __LINE__); } while(0)

/**
 *  @def glCompressedTexSubImage2D
 *  @brief specify a two-dimensional texture subimage in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_2D,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, or GL_TEXTURE_CUBE_MAP_NEGATIVE_Z.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] xoffset Specifies a texel offset in the x direction within the texture array.
 *  @param[in] yoffset Specifies a texel offset in the y direction within the texture array.
 *  @param[in] width Specifies the width of the texture subimage.
 *  @param[in] height Specifies the height of the texture subimage.
 *  @param[in] format Specifies the format of the compressed image data stored at address data.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
#define glCompressedTexSubImage2D(target,level,xoffset,yoffset,width,height,format,imageSize,data) do { GLFuncPtrName(glCompressedTexSubImage2D)(target, level, xoffset, yoffset, width, height, format, imageSize, data); GL_AUTOCHECK_BLOCK("glCompressedTexSubImage2D", __FILE__, __LINE__); } while(0)

/**
 *  @def glCompressedTexSubImage1D
 *  @brief specify a one-dimensional texture subimage in a compressed format
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_1D.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] xoffset Specifies a texel offset in the x direction within the texture array.
 *  @param[in] width Specifies the width of the texture subimage.
 *  @param[in] format Specifies the format of the compressed image data stored at address data.
 *  @param[in] imageSize Specifies the number of unsigned bytes of image data starting at the
 *      address specified by data.
 *  @param[in] data Specifies a pointer to the compressed image data in memory.
 */
#define glCompressedTexSubImage1D(target,level,xoffset,width,format,imageSize,data) do { GLFuncPtrName(glCompressedTexSubImage1D)(target, level, xoffset, width, format, imageSize, data); GL_AUTOCHECK_BLOCK("glCompressedTexSubImage1D", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetCompressedTexImage
 *  @brief return a compressed texture image
 *  @param[in] target Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D,
 *      GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
 *  @param[in] lod Specifies the level-of-detail number of the desired image. Level 0 is the base
 *      image level. Level n is the nth mipmap reduction image.
 *  @param[out] img Returns the compressed texture image.
 */
#define glGetCompressedTexImage(target,lod,img) do { GLFuncPtrName(glGetCompressedTexImage)(target, lod, img); GL_AUTOCHECK_BLOCK("glGetCompressedTexImage", __FILE__, __LINE__); } while(0)

#endif // GL_VERSION_1_3

//                              --- ~OpenGL 1.3 ---

